Bug 815516 - pam remember can check wrong username if it is a substring of another username
Summary: pam remember can check wrong username if it is a substring of another username
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: pam
Version: 6.3
Hardware: i386
OS: Linux
unspecified
medium
Target Milestone: rc
: 6.4
Assignee: Tomas Mraz
QA Contact: Dalibor Pospíšil
URL:
Whiteboard:
Depends On:
Blocks: 836160
TreeView+ depends on / blocked
 
Reported: 2012-04-23 18:40 UTC by Tomas Mraz
Modified: 2013-02-21 10:36 UTC (History)
3 users (show)

Fixed In Version: pam-1.1.1-12.el6
Doc Type: Bug Fix
Doc Text:
Cause: The pam_unix remember option functionality incorrectly matched user names in the /etc/security/opasswd file. Consequence: Users with their user name being a prefix of another user name could sometimes get incorrectly restricted with passwords of the other user when changing their password or overwrite old passwords of the other user account. Fix: The pam_unix module was fixed to properly match the whole user name when looking up records in /etc/security/opasswd file. Result: Users are now correctly restricted with their own old passwords and old password records of another user are no longer overwritten.
Clone Of: 768087
Environment:
Last Closed: 2013-02-21 10:36:56 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2013:0521 normal SHIPPED_LIVE Moderate: pam security, bug fix, and enhancement update 2013-02-20 21:28:50 UTC

Description Tomas Mraz 2012-04-23 18:40:07 UTC
+++ This bug was initially created as a clone of Bug #768087 +++

Description of problem:
The remember functionality of pam_unix can compare against the wrong username’s old passwords if the username is a substring of another username.  The substring must be at the beginning of both usernames for this to occur.  For example, a username ‘test’ will look at the old passwords of ‘test123’.

Version-Release number of selected component (if applicable):
pam-0.99.6.2-6.el5_5.2.i386.rpm

How reproducible:
Always

Steps to Reproduce:
1.  Make sure remember=8 or something similar is enabled on pam_unix in the password stack
2.  Create a user ‘test1’ and change the password a few times
3.  Create a user ‘test’ and change the password to a previous password of test1

  
Actual results:
The password change is denied, however, it should not have been.

Expected results:
The password change is allowed.

Additional info:

You can see the erroneous code in pam_unix_passwd.c inside of the pam_unix module directory (in function save_old_password):

    while (fgets(buf, 16380, opwfile)) {
    if (!strncmp(buf, forwho, strlen(forwho))) {

The fix is to search for a line that starts with the username followed immediately by a colon.  


The same erroneous code exists in "pam_unix_passwd.c" in function check_old_password:

    while (fgets(buf, 16380, opwfile)) {
        if (!strncmp(buf, forwho, strlen(forwho))) {

Comment 4 errata-xmlrpc 2013-02-21 10:36:56 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

http://rhn.redhat.com/errata/RHSA-2013-0521.html


Note You need to log in before you can comment on or make changes to this bug.